> ## Documentation Index
> Fetch the complete documentation index at: https://docs.korint.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List a customer's invoices



## OpenAPI

````yaml /openapi.json get /customers/{customerId}/invoices
openapi: 3.0.0
info:
  title: Korint API
  description: >-
    Quoting, policy issuance, billing, claims, documents and compliance for
    insurance distribution.
  version: 1.0.0
  contact: {}
servers:
  - url: https://api.korint.io
    description: Production
  - url: https://api.sandbox.korint.io
    description: Sandbox
security:
  - oauth2: []
  - bearerAuth: []
tags: []
paths:
  /customers/{customerId}/invoices:
    get:
      tags:
        - billing
      summary: List a customer's invoices
      operationId: BillingReadsController_listCustomerInvoices
      parameters:
        - name: tenant
          in: header
          required: true
          description: Your tenant identifier. Requests without it are rejected.
          schema:
            type: string
        - name: whenAt
          required: false
          in: query
          description: 'Optional: the whenAt datetime'
          schema:
            type: string
            format: date-time
        - name: simulatedAt
          required: false
          in: query
          description: 'Optional: the simulatedAt datetime'
          schema:
            type: string
            format: date-time
        - name: issuedAtOrder
          required: false
          in: query
          description: the issuedAt sort direction
          schema:
            default: asc
            type: string
        - name: branchId
          required: false
          in: query
          schema:
            pattern: >-
              ^branch(_test)?_[346789ABCDEFGHJKLMNPQRTUVWXYabcdefghijkmnpqrtwxyz]{21}$
            type: string
        - name: customerId
          required: true
          in: path
          schema:
            pattern: >-
              ^customer(_test)?_[346789ABCDEFGHJKLMNPQRTUVWXYabcdefghijkmnpqrtwxyz]{21}$
            type: string
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListCustomerInvoicesOutput'
        '404':
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/CustomerNotFoundErrorDto'
              examples:
                CUSTOMER_NOT_FOUND:
                  value:
                    code: CUSTOMER_NOT_FOUND
                    message: Customer {customerId} ({branchId}) not found
                    details: {}
          description: ''
components:
  schemas:
    ListCustomerInvoicesOutput:
      type: object
      properties:
        data:
          description: the list of items in the page
          type: array
          items:
            $ref: '#/components/schemas/InvoiceWithSignedUrlDto'
        pageInfo:
          description: the page info
          allOf:
            - $ref: '#/components/schemas/ResponsePageInfo'
        totalCount:
          type: number
          description: the total number of items
        currentPage:
          type: number
          description: the current page
        totalPages:
          type: number
          description: the total number of pages
      required:
        - data
        - pageInfo
        - totalCount
        - currentPage
        - totalPages
    CustomerNotFoundErrorDto:
      type: object
      properties:
        code:
          type: string
          enum:
            - CUSTOMER_NOT_FOUND
        message:
          type: string
          example: Customer {customerId} ({branchId}) not found
        details:
          $ref: '#/components/schemas/CustomerNotFoundDetailsDto'
      required:
        - code
        - message
        - details
    InvoiceWithSignedUrlDto:
      type: object
      properties:
        issuedAt:
          type: string
          description: invoice issuance date
        period:
          $ref: '#/components/schemas/Period'
        components:
          type: array
          items:
            $ref: '#/components/schemas/BillingComponentDto'
        lines:
          type: array
          items:
            $ref: '#/components/schemas/InvoiceLineDto'
        total:
          $ref: '#/components/schemas/AmountDto'
        reconciledInvoiceIds:
          description: Invoice ids that have been reconciled
          type: array
          items:
            type: array
        metadata:
          description: metadata assigned to the object
          type: array
          items:
            $ref: '#/components/schemas/Metadata'
        id:
          type: string
          description: the invoice id
        type:
          type: string
          description: entity type
          enum:
            - INVOICE
        status:
          type: string
          description: invoice status
          enum:
            - DRAFTED
            - ISSUED
            - PAID
            - FINALIZED
            - PAYMENT_DISPUTED
            - PAYMENT_IN_PROGRESS
            - PAYMENT_FAILED
            - RECONCILED
            - CANCELLED
            - REFUND_NOT_HANDLED
            - PARTIALLY_FINALIZED
            - REFUND_IN_PROGRESS
            - WRITTEN_OFF
        createdAt:
          type: string
          description: invoice creation date
        hasFailedOnce:
          type: boolean
          description: has invoice failed at least once
        firstFailedAt:
          type: string
          description: first invoice payment failure date
        incrementalId:
          type: number
          description: Incremental invoice id
        externalId:
          type: string
          description: External invoice id
        paymentId:
          type: string
          description: Invoice payment id, if PAID
        paidAt:
          type: string
          description: Payment date, if PAID
        paidEventCreatedAt:
          type: string
        finalizedAt:
          type: string
          description: Finalization date, if FINALIZED
        creditedInvoiceId:
          type: string
          description: Original invoice that we are crediting
        replacedInvoiceId:
          type: string
          description: Original invoice that we are replacing
        refundNotHandledReason:
          description: Reason for refund not handled
          allOf:
            - $ref: '#/components/schemas/InvoiceRefundNotHandledReason'
        signedUrl:
          type: string
          description: signed url for the invoice pdf
      required:
        - issuedAt
        - period
        - components
        - lines
        - total
        - metadata
        - id
        - type
        - status
        - createdAt
    ResponsePageInfo:
      type: object
      properties:
        first:
          type: boolean
          description: whether this is the first page
        last:
          type: boolean
          description: whether this is the last page
    CustomerNotFoundDetailsDto:
      type: object
      properties:
        customerId:
          type: string
        branchId:
          type: string
        whenAt:
          type: string
        simulatedAt:
          type: string
      required:
        - customerId
    Period:
      type: object
      properties:
        startedAt:
          format: date-time
          type: string
          description: the start date of the period
        endedAt:
          format: date-time
          type: string
          description: the end date of the period
      required:
        - startedAt
        - endedAt
    BillingComponentDto:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - PREMIUM
            - PERIL
            - FEE
            - TAX
            - SPECIAL
        premium:
          $ref: '#/components/schemas/AmountDto'
        reconciliation:
          type: boolean
      required:
        - id
        - type
        - premium
        - reconciliation
    InvoiceLineDto:
      type: object
      properties:
        label:
          type: string
        total:
          $ref: '#/components/schemas/AmountDto'
      required:
        - label
        - total
    AmountDto:
      type: object
      properties:
        amountPreFeesAndTaxes:
          type: integer
        fees:
          type: array
          items:
            $ref: '#/components/schemas/FeeDto'
        totalFees:
          type: integer
        amountWithFeesPreTaxes:
          type: integer
        taxes:
          type: array
          items:
            $ref: '#/components/schemas/TaxDto'
        totalTaxes:
          type: integer
        amountWithFeesAndTaxes:
          type: integer
      required:
        - amountPreFeesAndTaxes
        - fees
        - totalFees
        - amountWithFeesPreTaxes
        - taxes
        - totalTaxes
        - amountWithFeesAndTaxes
    Metadata:
      type: object
      properties:
        key:
          type: string
          description: the key of the metadata
        value:
          type: string
          description: the value of the metadata
      required:
        - key
        - value
    InvoiceRefundNotHandledReason:
      type: string
      enum:
        - SEPA_PAYMENT_180_DAYS_EXCEEDED
        - INSUFFICIENT_AMOUNT
      description: Reason for refund not handled
    FeeDto:
      type: object
      properties:
        id:
          type: string
        brokerageFirmId:
          type: string
        chargeType:
          type: string
          enum:
            - ONE_TIME
            - SPOT
            - RECURRING
        amount:
          type: integer
      required:
        - id
        - chargeType
        - amount
    TaxDto:
      type: object
      properties:
        id:
          type: string
        chargeType:
          type: string
          enum:
            - ONE_TIME
            - SPOT
            - RECURRING
        amount:
          type: integer
      required:
        - id
        - chargeType
        - amount
  securitySchemes:
    oauth2:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://korint-tenant.auth.eu-west-3.amazoncognito.com/oauth2/token
          scopes:
            korint.io/account: Read account information
            korint.io/analytics: Access analytics endpoints
            korint.io/assets: Access asset endpoints
            korint.io/billing: Access billing endpoints
            korint.io/branches: Access branch endpoints
            korint.io/broker: Access broker endpoints
            korint.io/claims: Access claim endpoints
            korint.io/comments: Access comment endpoints
            korint.io/customers: Access customer endpoints
            korint.io/derogations: Access derogation endpoints
            korint.io/documents: Access document endpoints
            korint.io/external: Access external lookup endpoints
            korint.io/external-claims: Declare claims from an external system
            korint.io/internal-notes: Access internal note endpoints
            korint.io/invitations: Access invitation endpoints
            korint.io/payments: Access payment endpoints
            korint.io/permissions: Access permission management endpoints
            korint.io/policies: Access policy endpoints
            korint.io/quotes: Access quote endpoints
            korint.io/reportings: Access reporting endpoints
            korint.io/signature: Access signature endpoints
      description: >-
        Machine-to-machine clients use the OAuth 2.0 client credentials grant.
        Each tenant has its own authorization server: in the token URL below,
        replace `tenant` with your tenant identifier.
    bearerAuth:
      scheme: bearer
      bearerFormat: JWT
      type: http
      description: An access token obtained from your tenant authorization server.

````